import java.io.*;
import java.util.*;


public class main{

public static int subnetsize=4;
public static int watchForThisCanonic=-1;//set to -1 to get rid of annoying outputs //4369
public static final boolean considerInhibitory=true;
public static final boolean environmentAsNode=false;
public static final boolean differentiationAsNode=false;
public static java.util.Random rand=new java.util.Random(23051981);
public static int genSearchLimit=748;//-1;//248;//498;//748;
public static int startGeneNo=9;

public static String[] split(String what, String delim){
StringTokenizer x=new StringTokenizer(what,delim,true);
Vector y=new Vector();
//String[] ret=new String[x.countTokens()];
int max=x.countTokens();
String t;
int last=-1;
     for(int i=0;i<max;i++) {
         t=x.nextToken();
         if(t.equals(delim)){
           if(last==i-1){
             y.add("");
             }
           last=i;
           }
         else
           y.add(t);
     }
String[] ret=new String[y.size()];
     for(int i=0;i<ret.length;i++) {
         ret[i]=""+y.elementAt(i);
     }
return ret;
}



public static int[] stringToIntArr(String in){
int[] ret=new int[in.length()];
int j=0;
for(int i=0;i<ret.length;i++)
 try{
  ret[j]=Integer.parseInt(""+in.charAt(i));
  j++;
 }catch(Exception e){}
int[] ret2=new int[j];
System.arraycopy(ret,0,ret2,0,j);
return ret2;
}

public static network getNetwork(int[] genome, int func, boolean induce){
String geno=KnabeGRN.intArrToString(genome);
String[] t=geno.split("3");
KnabeGRN.geneNo=t.length-1;
GRNconverter z=new GRNconverter(genome);
return z.getNetwork(true,func,induce);
}

public static double getFitness(int[] genome, int func, int fitFunc, int GRNtype){
String geno=KnabeGRN.intArrToString(genome);
String[] t=geno.split("3");
KnabeGRN.geneNo=t.length-1;
GRNconverter z=new GRNconverter(genome);
if(GRNtype==1)
  z.makeParts();
return z.getRunFit(func,fitFunc,GRNtype);
}

//this will destroy a random link and get us the new fitness of the GRN
public static double getLesionedFitness(int[] genome, int func, int fitFunc, int GRNtype){

String geno=KnabeGRN.intArrToString(genome);
String[] s=geno.split("3");
KnabeGRN.geneNo=s.length-1;
GRNconverter z=new GRNconverter(genome);
if(GRNtype!=0)
  z.makeParts();

   int[][] newrk = z.getNetwork().getConnectivityMatrixArray();
   //network.printConnectivityMatrix(newrk,true);
   int x; int y;
   do{
    x=rand.nextInt(newrk.length);
    y=rand.nextInt(newrk[0].length);
   }while(newrk[x][y]==0);
   z.destroy(x,y);
   //newrk = z.getNetwork().getConnectivityMatrixArray();
   //network.printConnectivityMatrix(newrk,true);

return z.getRunFit(func,fitFunc,GRNtype);
}

public static int getMostSignificantMotif(double[] c1, double[] c2, double[] stdDevs,int subnetsize){
int best=-1;
double Z=0.0;
for(int i=0;i<c1.length;i++)
  if((c2[i]>0.01)&&((c1[i]-c2[i])>stdDevs[i])&&!badSubNet(network.canonicalIntToConnMat(i,subnetsize*subnetsize))){
   //System.out.println("The network with canonical number "+i+" has been found on avg. "+c1[i]+" and "+c2[i]+" times, a difference of "+(c1[i]-c2[i]+" that is "+((c1[i]-c2[i])/stdDevs[i])+" Z (std.dev. "+stdDevs[i]));
   if(((c1[i]-c2[i])/stdDevs[i])>Z){
    Z=((c1[i]-c2[i])/stdDevs[i]);
    best=i;
    }
   }
//System.out.println("Best motif: "+best+" was found "+c1[best]+" times and had Z value: "+Z);
//network.printConnectivityMatrix(network.canonicalIntToConnMat(best,subnetsize*subnetsize));
return best;
}


//This will destroy a link of the most significantly strongly represented motif
public static double getTargetedLesionedFitness(int[] genome, int func, int fitFunc, int GRNtype, double[] randomMotifCounts, double[] stdDevs){
String geno=KnabeGRN.intArrToString(genome);
String[] s=geno.split("3");
KnabeGRN.geneNo=s.length-1;
GRNconverter z=new GRNconverter(genome);
if(GRNtype!=0)
  z.makeParts();


//begin count for this net:
boolean metabolic=false;
network m;
if(metabolic)
 m=getNetwork(genome,func,false);//run it really and see what is used
else
 m=getNetwork(genome);//only structural info from genome
int[][] nework=m.getConnectivityMatrixArray(considerInhibitory);
double[] thisNet=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  thisNet[t]++;
  }
//end count for this net

int motifNum=getMostSignificantMotif(thisNet, randomMotifCounts, stdDevs, subnetsize);

//do the lesioning:
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,z.getNetwork().getConnectivityMatrixArray())){
  int t=network.getCanonicalInt(newrk);
  if(t==motifNum){int x;int y;
   //for(int i=0;i<network.lastIn.length;i++)
   //  System.out.print(network.lastIn[i]+" ");
   //System.out.println();
   //network.printConnectivityMatrix(newrk,true);
   do{
   x=rand.nextInt(subnetsize);
   y=rand.nextInt(subnetsize);
   }while(newrk[x][y]==0);
   z.destroy(network.lastIn[x],network.lastIn[y]);
   break; //HERE: ONLY DAMAGE ONE CONNECTION OF THE FIRST FOUND MOTIF OCCURENCE
   }
  }

return z.getRunFit(func,fitFunc,GRNtype);
}

public static network getNetwork(int[] genome){
String geno=KnabeGRN.intArrToString(genome);
String[] t=geno.split("3");
KnabeGRN.geneNo=t.length-1;
GRNconverter z=new GRNconverter(genome);
if(differentiationAsNode)
 return z.getNetworkWithEnvironmentAndDifferentiation();
else{
 if(environmentAsNode)
  return z.getNetworkWithEnvironmentAndDifferentiation();//can also be changed to "getNetworkWithEnvironment" without "AndDifferentiation"
 else
  return z.getNetwork();
 }
}


public static void swap(int[] s, int i, int j){
if(i!=j){
 int t=s[i];
 s[i]=s[j];
 s[j]=t;
 }
System.out.println(i+" "+j);
}

public static void browseDir(File dirname, Vector<int[][]> res, boolean metabolic, boolean induce){
browseDir(dirname, res, metabolic, induce, true, null, null);
}

public static void browseDir(File dirname, Vector<int[][]> res, boolean metabolic, boolean induce, boolean getBest, double[] randomMotifCounts, double[] stdDevs){
try{
  File[] z=dirname.listFiles(new FileFilter(){public boolean accept(File what){return what.isDirectory();}});
  if(z.length!=0)//no sub-directories, so we have found a leaf
   for(File fn:z){
//    System.out.println(fn.getName());
    browseDir(fn,res,metabolic,induce,getBest,randomMotifCounts,stdDevs);
    }
  else
   if(dirname.getName().length()==1){//!!!only if dirname is a single number we are right!!!
    z=dirname.listFiles();
    int t;
    if(getBest)
      t=0;
    else
      t=Integer.MAX_VALUE;
    File highest=null;
    for(File fn:z){
     int t2=Integer.parseInt(fn.getName().substring(fn.getName().lastIndexOf("Gen")+3,fn.getName().lastIndexOf(".")));
     if(getBest){//get newest net from every diretory
      if(t2>t){
       t=t2;
       highest=fn;
       }
      }
     else{
      if((t2<t)&&(t2>genSearchLimit)){  //get youngest (in gen. terms) 
       t=t2;                            //net > genSearchLimit from every directory
       highest=fn;
       }
      }
     }
    if(highest!=null){
     String pathname=highest.getAbsolutePath();
     int currFunc=Integer.parseInt(pathname.substring(pathname.lastIndexOf(')')+2,pathname.lastIndexOf(')')+3));
     int fitFunc=Integer.parseInt(pathname.substring(pathname.lastIndexOf("FitFunc")-1,pathname.lastIndexOf("FitFunc")));
     double originalFitness=9999999.9;
     File file = null;
     PrintWriter out = null;
     BufferedReader geno =null;
     String read ="";
              geno=new BufferedReader(
                    new FileReader(
                    highest));
              read= geno.readLine(); //fitness data only
              try{
                 int offs=read.lastIndexOf("fitness: ");
                 originalFitness=Double.parseDouble(read.substring(offs+9,read.indexOf(' ',offs+10)));
                 }
              catch(Exception e){System.err.println("NUMBER FORMAT!\r\n"+read+"\r\n"+e); System.exit(1);}
              read= geno.readLine(); //the genome
     String gg=read.replace(',',' ');
     gg=gg.replace('{',' ');
     gg=gg.replace('}',' ');
     int[] geneInts=stringToIntArr(gg);

     if(randomMotifCounts!=null){
      int GRNtype=1;
      if(pathname.indexOf("original")>=0)
        GRNtype=0;
      double tf=getFitness(geneInts,currFunc,fitFunc,GRNtype);
      double targetedLesionFit=getTargetedLesionedFitness(geneInts,currFunc,fitFunc,GRNtype,randomMotifCounts,stdDevs);
      double randomLesionFit=getLesionedFitness(geneInts,currFunc,fitFunc,GRNtype);
      //System.out.println(tf+", "+randomLesionFit+", "+targetedLesionFit+" "+pathname);
      System.out.println((tf-randomLesionFit)+", "+(tf-targetedLesionFit));
      double tfdifference=1.0-(tf/originalFitness);//just calculate to make sure we got everything right
      if(Math.abs(tfdifference)>4.0)
        System.err.println("\r\n\r\nRelative performance difference: "+tfdifference+"  ("+tf+" : "+originalFitness+" / "+pathname+" )\r\n\r\n");
      double randdifference=1.0-(randomLesionFit/originalFitness);
      double targeteddifference=1.0-(targetedLesionFit/originalFitness);
      //System.out.println(randdifference+", "+targeteddifference);
      }

     network x;
     if(metabolic)
       x=getNetwork(geneInts,currFunc,induce);//run it really and see what is used
     else
       x=getNetwork(geneInts);//only structural info from genome
     res.add(x.getConnectivityMatrixArray(considerInhibitory));
     }
    }
}catch(Exception e){System.err.println("Error while searching for files: "); e.printStackTrace(); System.exit(1);}
}

public static void compare(double[] c1, double[] c2, double[] stdDevs,int subnetsize){
/*NORMALIZING SHOULD NO LONGER BE NEEDED AS WE NOW EXPECT THE Ci DOUBLE[] TO BE AVGs
//do we need to normalize?
double c1Sum=0;
for(int i=0;i<c1.length;i++){
  c1Sum+=c1[i];
}
double c2Sum=0;
for(int i=0;i<c1.length;i++){
  c2Sum+=c2[i];
}
if(c1Sum>c2Sum){
  double ratio=c1Sum/c2Sum;
  for(int i=0;i<c1.length;i++){
   c1[i]/=ratio;
  }
 }
else
 if(c1Sum<c2Sum){
  double ratio=c2Sum/c1Sum;
  for(int i=0;i<c1.length;i++){
   c2[i]/=ratio;
  }
 }


c1Sum=0;
for(int i=0;i<c1.length;i++){
  c1Sum+=c1[i];
}
c2Sum=0;
for(int i=0;i<c1.length;i++){
  c2Sum+=c2[i];
}
System.out.println("Sums after normalizing: "+c1Sum+" and "+c2Sum);
*/

//output results
for(int i=0;i<c1.length;i++)
  if((i==watchForThisCanonic)||((c1[i]-c2[i])>stdDevs[i])){//limit too extreme???
   System.out.println("------------------------------------------------");
   System.out.println("The network with canonical number "+i+" has been found on avg. "+c1[i]+" and "+c2[i]+" times, a difference of "+(c1[i]-c2[i]+" that is "+((c1[i]-c2[i])/stdDevs[i])+" Z (std.dev. "+stdDevs[i]));
   
   network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
   System.out.print("------------------------------------------------");
  //System.out.println(i+": "+cnt[i]);
  }
System.out.println("------------------------------------------------");
}

public static double getAvgDensity(Vector<int[][]> nets){
double sum=0;
for(int[][] nework: nets){
  sum+=network.getDensity(nework);
  }
double avg=sum/(nets.size()*1.0);
double diffSum=0;
for(int[][] nework: nets){
  double diff=(network.getDensity(nework)-avg);
  diffSum+=diff*diff;
  }
double sigma=Math.sqrt(diffSum/nets.size());
double stdErr=sigma/Math.sqrt(nets.size());
System.out.println("Density: "+avg+" +/- "+sigma+" ("+stdErr+" std.err.)");
return avg;
}

public static void doModularityAnalysis(Vector<int[][]> nets){
doModularityAnalysis(nets,false);
}

public static void doModularityAnalysis(Vector<int[][]> nets,boolean checkModuleStructure){
double sumMaxModularity=0;
double sumModuleNumber= 0;
double[] canonicModules=null;
if(checkModuleStructure)
  canonicModules=new double[(int)Math.pow(2,subnetsize*subnetsize)];
double[] modNumBuffer=new double[nets.size()];
int jk=0;
for(int[][] nework: nets){
 double[] res=network.getMaximumModularity(nework);
 sumMaxModularity+=res[0];
 sumModuleNumber +=res.length-1;
 modNumBuffer[jk++]=res.length-1; //buffer values so that we can later calculate std.dev.
 if(checkModuleStructure){//begin checkModuleStructure
  for(int i=0;i<res.length-1;i++){
   network ttt=new network(nework);
   int[] part=new int[res.length-1];
   for(int j=0;j<part.length;j++)
     part[j]=(int)res[j+1];
   ttt.partition(part);
   if(res[i+1]==subnetsize){//this subnetwork has the size we are looking for, check it
    int t=network.getCanonicalInt(ttt.getSubclassConnectivityMatrixArray(i));
    canonicModules[t]++;
    }
   }
  }//end checkModuleStructure
 }//end for nets
 
double avgModNum=(sumModuleNumber/(double)nets.size());
//calculate module number std.dev.
double diffSum=0;
for(int i=0;i<modNumBuffer.length;i++)
  diffSum+=(modNumBuffer[i]-avgModNum)*(modNumBuffer[i]-avgModNum);
double modNumSigma=Math.sqrt(diffSum/(double)nets.size());

 if(checkModuleStructure) //output checkModuleStructure results
  for(int i=0;i<canonicModules.length;i++)
   if(canonicModules[i]>0){
    System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++");
    System.out.println("The network with canonical number "+i+" has been considered a module "+canonicModules[i]+" times");
    network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
    System.out.print("+++++++++++++++++++++++++++++++++++++++++++++++");
   }
System.out.println("The networks have an avg. maximum modularity of: "+(sumMaxModularity/(double)nets.size())+
                   " with an avg. number of modules of: "+avgModNum+" +/- "+modNumSigma);
}

public static void doComparisons(){

//do counting for twoFuncsSlow
Vector<int[][]> nets=null;
try{
  nets=new Vector<int[][]>();
  browseDir(new File("attractor/attractor_slowShift"),nets,true,false);//GRN_twoFuncsNew_slowShift
  System.out.println("Found "+nets.size()+" best nets in GRN_twoFuncsNew_slowShift!");
  System.out.println("The average network density is: "+getAvgDensity(nets));
  doModularityAnalysis(nets);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsSlow=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases

int[] motifNotFound=new int[twoFuncsSlow.length];
for(int[][] nework: nets){
 int z=0;
 boolean[] motifNotFoundTrack=new boolean[twoFuncsSlow.length];
 for(int i=0;i<motifNotFoundTrack.length;i++)
  motifNotFoundTrack[i]=true;
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  if(t==watchForThisCanonic){
   z++;
   network.printConnectivityMatrix(newrk,true);
   }
  twoFuncsSlow[t]++;
  motifNotFoundTrack[t]=false;
  }
 if((watchForThisCanonic>=0))
   System.out.println("Subnetwork "+watchForThisCanonic+" found "+z+" times!");
 for(int i=0;i<motifNotFound.length;i++)
   if(motifNotFoundTrack[i]) //this subnetwork was not found at all in this net
     motifNotFound[i]++;
 }
for(int i=0;i<motifNotFound.length;i++)
  if((motifNotFound[i]<50)||(i==watchForThisCanonic)){
    network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
    System.out.println("above (canoncial number "+i+") was not found in "+motifNotFound[i]+" nets.");
    }
/*
//do counting for twoFuncsSlowBadNets
Vector<int[][]> netz=null;
try{
  netz=new Vector<int[][]>();
  browseDir(new File("GRN_twoFuncsNew_slowShift"),netz,false,false,false);
  System.out.println("Found "+netz.size()+" bad nets!");
  System.out.println("The average network density is: "+getAvgDensity(netz));
  doModularityAnalysis(netz);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsSlowBadNets=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: netz)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsSlowBadNets[t]++;}

//do counting for randomized nets
double[] twoFuncsSlowRand=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] newo: nets){
 int[][] nework=network.randomizeConnectivityMatrix(newo);
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsSlowRand[t]++;
  }
 }

//do counting for twoFuncsFull
Vector<int[][]> nets2=null;
try{
  nets2=new Vector<int[][]>();
  browseDir(new File("GRN_twoFuncsNew_fullShift"),nets2,false,false);
  System.out.println("Found "+nets2.size()+" best nets in GRN_twoFuncsNew_fullShift!");
  System.out.println("The average network density is: "+getAvgDensity(nets2));
  doModularityAnalysis(nets2);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsFull=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: nets2)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsFull[t]++;}
*/

//do counting for originalSetting
Vector<int[][]> nets3=null;
try{
  nets3=new Vector<int[][]>();
  browseDir(new File("originalLongRun"),nets3,true,false);
  System.out.println("Found "+nets3.size()+" best nets in originalLongRun!");
  System.out.println("The average network density is: "+getAvgDensity(nets3));
  doModularityAnalysis(nets3);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] originalSetting=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: nets3)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  originalSetting[t]++;}
/*
//do counting for originalSettingReversve
Vector<int[][]> nets5=null;
try{
  nets5=new Vector<int[][]>();
  browseDir(new File("GRN_originalReverse"),nets5,false,false);
  System.out.println("Found "+nets5.size()+" best nets in GRN_originalReverse!");
  System.out.println("The average network density is: "+getAvgDensity(nets5));
  doModularityAnalysis(nets5);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] reverseSetting=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: nets5)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  reverseSetting[t]++;}
*/
//compare(twoFuncsSlow,originalSetting,subnetsize);//twoFuncsFull //twoFuncsSlowBadNets
System.out.println("check 0: old compare!");
}


public static void modularityTest(){
network test=new network(6);
test.addNodes(6);
test.link(0,0);
test.link(0,1);
test.link(1,1);
test.link(1,2);
test.link(0,2);
test.link(2,1);
test.link(2,0);

test.link(3,4);
test.link(3,3);
test.link(4,3);
test.link(4,4);
test.link(5,3);
test.link(5,4);
test.link(3,5);

test.link(3,2);
test.link(2,3);

/*test.partition(new int[]{3,3});
test.printConnectivityMatrix();
network.printConnectivityMatrix(test.getSubclassConnectivityMatrixArray(0));
network.printConnectivityMatrix(test.getSubclassConnectivityMatrixArray(1));
*/
double[] res=test.getMaximumModularity(test.getConnectivityMatrixArray());
test.printConnectivityMatrix();
System.out.print("Maximum modularity for above network:");
for(int i=0;i<res.length;i++)
  System.out.print(res[i]+",");
System.out.println();
}



public static void doComparisons2(){

//do counting for twoFuncsSlow
Vector<int[][]> nets=null;
try{
  nets=new Vector<int[][]>();
  browseDir(new File("GRN_twoFuncsNew_slowShift"),nets,false,false);
  System.out.println("Found "+nets.size()+" best nets in GRN_twoFuncsNew_slowShift!");
  System.out.println("The average network density is: "+getAvgDensity(nets));
  doModularityAnalysis(nets);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsSlow=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases

int[] motifNotFound=new int[twoFuncsSlow.length];
for(int[][] nework: nets){
 int z=0;
 boolean[] motifNotFoundTrack=new boolean[twoFuncsSlow.length];
 for(int i=0;i<motifNotFoundTrack.length;i++)
  motifNotFoundTrack[i]=true;
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  if(t==watchForThisCanonic){
   z++;
   network.printConnectivityMatrix(newrk,true);
   }
  twoFuncsSlow[t]++;
  motifNotFoundTrack[t]=false;
  }
 if((watchForThisCanonic>=0))
   System.out.println("Subnetwork "+watchForThisCanonic+" found "+z+" times!");
 for(int i=0;i<motifNotFound.length;i++)
   if(motifNotFoundTrack[i]) //this subnetwork was not found at all in this net
     motifNotFound[i]++;
 }
for(int i=0;i<motifNotFound.length;i++)
  if((motifNotFound[i]<50)||(i==watchForThisCanonic)){
    network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
    System.out.println("above (canoncial number "+i+") was not found in "+motifNotFound[i]+" nets.");
    }

//do counting for twoFuncsSlowBadNets
Vector<int[][]> netz=null;
try{
  netz=new Vector<int[][]>();
  browseDir(new File("GRN_twoFuncsNew_slowShift"),netz,false,false);
  System.out.println("Found "+netz.size()+" bad nets!");
  System.out.println("The average network density is: "+getAvgDensity(netz));
  doModularityAnalysis(netz);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsSlowBadNets=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: netz)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsSlowBadNets[t]++;}

//do counting for randomized nets
double[] twoFuncsSlowRand=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] newo: nets){
 int[][] nework=network.randomizeConnectivityMatrix(newo);
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsSlowRand[t]++;
  }
 }

//do counting for twoFuncsFull
Vector<int[][]> nets2=null;
try{
  nets2=new Vector<int[][]>();
  browseDir(new File("GRN_twoFuncsNew_fullShift"),nets2,false,false);
  System.out.println("Found "+nets2.size()+" best nets in GRN_twoFuncsNew_fullShift!");
  System.out.println("The average network density is: "+getAvgDensity(nets2));
  doModularityAnalysis(nets2);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsFull=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: nets2)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsFull[t]++;}

//compare(twoFuncsSlow,twoFuncsSlowRand,subnetsize);//twoFuncsFull //twoFuncsSlowBadNets
System.out.println("check 1: old compare!");

}

public static boolean tester(){
KnabeGRN.geneNo=9;
int[] genome=new int[KnabeGRN.geneNo*10+39];//12:4 for a cis site + 2 for cis delimiters + 4 for protein produced + 2 for gene delimiters
java.util.Random rand=new java.util.Random();
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  //System.out.print(next+",");
  genome[i]=next;
}
for(int i=0;i<KnabeGRN.geneNo;i++){
  genome[i*10+9]=3;
  genome[i*10+4]=2;
}

KnabeGRN z=new KnabeGRN(genome);

//KnabeGRN.setInputFunction(whatFunction);
//KnabeGRN.setFitFunction(whatMeasure);
GRNconverter t=new GRNconverter((z.getRandomInd()).getGenome());
network x=t.getNetwork();
x.printConnectivityMatrix();
 for(int[][] newrk: network.getAllNbyNsubMatrices(4,x.getConnectivityMatrixArray())){
  int j=network.getCanonicalInt(newrk);
  //if(j==4369) return true;
    if(j==13107) return true;
   //System.out.println("HOORAY");
 }
return false;
}

public static double[] an(File whatDir){
return an(whatDir,null,null);
}

//This function does the analysis of one directory for you, pattern occurences
//numbers are counted and returned as double[], if not null as parameter then
//pattern occurences in randomized nets are counted into motifsWhenRandomized[],
//finally, to make it real motifs we need to know the std.deviations of pattern
//occurences in the nets

//this will return true when the first node of this network has no output and no input
//that is useful because unconnected nodes are not of interested almost always
public static boolean badSubNet(int[][] ret){
          boolean kickout=true;
          for(int i=0;i<ret[0].length;i++){
           if(ret[0][i]!=0)
            kickout=false;
           if(ret[i][0]!=0)
            kickout=false;
           }
          int ccc=0;
          for(int i=0;i<ret.length;i++)
           for(int j=0;j<ret[0].length;j++)
            if(ret[i][j]!=0)
             ccc++;
          if(ccc<3)//not enough connections, somebody is not in!
            kickout=true;
          if(kickout)
            return true;
return false;
}

public static double[] an(File whatDir,double[] motifsWhenRandomized, double[] motifStdDevs){
return an(whatDir,motifsWhenRandomized,motifStdDevs,null,null,null);
}

public static double[] an(File whatDir,double[] motifsWhenRandomized, double[] motifStdDevs, int[][] allData){
return an(whatDir,motifsWhenRandomized,motifStdDevs,allData,null,null);
}

public static double[] an(File whatDir,double[] motifsWhenRandomized, double[] motifStdDevs, int[][] allData,  double[] compRandomMotifCounts, double[] compMotifStdDevs){
Vector<int[][]> nets2=null;
try{
  nets2=new Vector<int[][]>();
  browseDir(whatDir,nets2,false,false,false,  compRandomMotifCounts,compMotifStdDevs);
  System.out.println("Found "+nets2.size()+" best nets in "+whatDir.getName()+" !");
  System.out.println("The average network density is: "+getAvgDensity(nets2));
  doModularityAnalysis(nets2);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] resMotifs=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
int i=0;
int watchCount=0;
int watchNotFound=0;
int[][] tmo;
if(allData!=null)
  tmo=allData;
else
  tmo=new int[nets2.size()][(int)Math.pow(2,subnetsize*subnetsize)];
for(int[][] nework: nets2){
 watchCount=0;
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework))
  if(!badSubNet(newrk))
   {
   int t=network.getCanonicalInt(newrk);
   if(t==watchForThisCanonic){
     watchCount++;
     }
   tmo[i][t]++;               //record also every single detail for std.dev. calculation
   resMotifs[t]++;
   if(watchForThisCanonic>0){
    if(watchCount>0)
     System.out.println("Found pattern "+watchForThisCanonic+" "+watchCount+" times in net "+i);
    else
     watchNotFound++;
    }
   }
 i++;
 }
System.out.println("Pattern "+watchForThisCanonic+" was not found in "+watchNotFound+" nets!");
if(motifsWhenRandomized!=null){
 for(int[][] newo: nets2){
  int[][] nework=network.randomizeConnectivityMatrix(newo);
  for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework))
   if(!badSubNet(newrk)){
    int t=network.getCanonicalInt(newrk);
    motifsWhenRandomized[t]++; //this is good for the sum (average)
   }
  }
 }
if(motifStdDevs!=null){
  for(int j=0;j<motifStdDevs.length;j++){
   double sigma=0;
   for(int k=0;k<nets2.size();k++){
    double diff=tmo[k][j]-(resMotifs[j]/((double)nets2.size()));
    sigma+=diff*diff;
    }
   motifStdDevs[j]=Math.sqrt(sigma/(double)nets2.size());
   }
  }

/*for(int moti=0;moti<motifStdDevs.length;moti++){
 int motiCnt=0;
 System.out.print(moti + "  " + resMotifs[moti]+ "  ");
 for(int j=0;j<nets2.size();j++)
  motiCnt+=tmo[j][moti];
 System.out.println(motiCnt);
}*/

for(int j=0;j<resMotifs.length;j++){ //get averages, i.e. divide by number of networks
  resMotifs[j]/=(double)nets2.size();
  if(motifsWhenRandomized!=null)
    motifsWhenRandomized[j]/=(double)nets2.size();
  }

 return resMotifs; 
}

public static void writeMotifDistribution(double[] res, double[] stdDevs, int[] motifMappings, String filename){
File file = null;
PrintWriter out = null;
try{
  file = new File(filename);
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
for(int i=0;i<motifMappings.length;i++)
 if(motifMappings[i]>0){
  out.println(motifMappings[i]+" "+res[i]+" "+stdDevs[i]+" #"+i);
  //network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
  }
out.close();
}

public static void addShowMotifs(double[] res,boolean[] showMotifs,double cutOffValue){
for(int i=0;i<res.length;i++)
 if(res[i]>cutOffValue)
  showMotifs[i]=true;
}

public static void writeForStatistics(int[][] tmo1, int[][] tmo2, int[] motifMappings, String filename){
File file = null;
PrintWriter out = null;
try{
  file = new File(filename);
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
for(int i=0;i<tmo1.length;i++){        //nets
  for(int j=0;j<motifMappings.length;j++){ //motifs
    if(motifMappings[j]>0){
      out.print(tmo1[i][j]+","+tmo2[i][j]+",");
      }
    }
  out.println();
  }
//tmo1[nets][motif]
out.close();
}

public static void doComparisonsBigPop(){
double[][] res=new double[6][];
double[][] randRes=new double[6][];
double[][] stdDevRes=new double[6][];
int[][][] allData=new int[6][80][(int)Math.pow(2,subnetsize*subnetsize)];

for(int i=0;i<randRes.length;i++)
  randRes[i]=new double[(int)Math.pow(2,subnetsize*subnetsize)];
for(int i=0;i<stdDevRes.length;i++)
  stdDevRes[i]=new double[(int)Math.pow(2,subnetsize*subnetsize)];

       //res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift2"),randRes[0],stdDevRes[0]);
//res[2]=an(new File("checkThese/GRN_RandFit750Run_twoFuncsNew_slowShift"),randRes[2],stdDevRes[2],allData[2]);
//res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift"),randRes[0],stdDevRes[0],allData[0],   res[2],stdDevRes[2]);
       //res[2]=an(new File("attractor/attractor_slowShift"),randRes[2],stdDevRes[2]);
       //res[3]=an(new File("checkThese/original750Run"),randRes[3],stdDevRes[3]);





/*
res[0]=an(new File("checkThese/original750Run"),randRes[0],stdDevRes[0]);
genSearchLimit=498;
res[2]=an(new File("checkThese/original750Run"),randRes[2],stdDevRes[2]);
compare(res[0],res[2],randRes[0],subnetsize);
System.exit(0);
*/


res[2]=an(new File("checkThese/GRN_RandFit750Run_twoFuncsNew_slowShift"),randRes[2],stdDevRes[2],allData[2]);//RandomFit
res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift"),randRes[0],stdDevRes[0],allData[0],   res[2],stdDevRes[2]);
double cutOffValue=0.2; //motif occurences smaller than this will be considered irrelevant
boolean[] showMotifs=new boolean[(int)Math.pow(2,subnetsize*subnetsize)];
for(int i=0;i<showMotifs.length;i++)
  showMotifs[i]=false;
addShowMotifs(res[0],showMotifs,cutOffValue);//if at least in one of these data sets an occurence level
addShowMotifs(res[2],showMotifs,cutOffValue);//above cutOffValue is found we show it
//begin numberShowingMotifs
int[] motifMappings=new int[(int)Math.pow(2,subnetsize*subnetsize)];
int mapNum=10;
for(int i=0;i<showMotifs.length;i++)
 if(showMotifs[i]){
  motifMappings[i]=mapNum;
  mapNum=mapNum+10;
  }
//end numberShowingMotifs
writeMotifDistribution(res[0],stdDevRes[0],motifMappings,"test1.txt");
writeMotifDistribution(res[2],stdDevRes[2],motifMappings,"test2.txt");

writeForStatistics(allData[0],allData[2],motifMappings,"stats.txt");
compare(res[0],res[2],stdDevRes[2],subnetsize);


//genSearchLimit=188;

//watchForThisCanonic=118;
//res[0]=an(new File("checkThese/original750Run"),randRes[0],stdDevRes[0]);
//res[1]=an(new File("checkThese/original750Run.2nd"),randRes[1],stdDevRes[1]);

//watchForThisCanonic=-1;
//res[2]=an(new File("checkThese/originalRandomFit750Run"),randRes[2],stdDevRes[2]);

//compare(res[0],res[2],stdDevRes[2],subnetsize);
/*double resSum=0;
double randResSum=0;
double stdDevSum=0;
for(int i=0;i<res[0].length;i++){
  System.out.println(res[0][i]+"  "+randRes[0][i]+"  "+stdDevRes[0][i]);
  resSum+=res[0][i];
  randResSum+=randRes[0][i];
  stdDevSum+=stdDevRes[0][i];
  }
System.out.println(resSum+"        "+randResSum+"        "+stdDevSum);
*/
System.exit(0);
res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift2"),randRes[0],stdDevRes[0]);
//res[2]=an(new File("checkThese/GRN_RandFit750Run_twoFuncsNew_slowShift"),randRes[2]);

//int[][] nework=network.randomizeConnectivityMatrix(newo);

//compare(res[0],randRes[0],subnetsize);

/*res[1]=an(new File("checkThese/GRN_AntiFit750Run_twoFuncsNew_slowShift"),randRes[1]);
res[2]=an(new File("checkThese/GRN_RandFit750Run_twoFuncsNew_slowShift"),randRes[2]);
res[3]=an(new File("checkThese/original750Run"),randRes[3]);
res[4]=an(new File("checkThese/originalAntiFit750Run"),randRes[4]);
res[5]=an(new File("checkThese/originalRandomFit750Run"),randRes[5]);
System.out.println("check 10: old compare!");
compare(res[0],res[3],subnetsize);
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("XXXXXXXXXXXXXXXXXXXXXXXXXXXX");
System.out.println("check 11: old compare!");
compare(res[2],res[5],subnetsize);
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("YYYYYYYYYYYYYYYYYYYYYYYYYYYY");
System.out.println("check 12: old compare!");
compare(res[0],randRes[0],subnetsize);
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
System.out.println("check 13: old compare!");
compare(res[3],randRes[3],subnetsize);
*/
}

public static void doComparisons3(){

//do counting for twoFuncsSlow
Vector<int[][]> nets=null;
try{
  nets=new Vector<int[][]>();
  browseDir(new File("attractor/attractor_slowShift"),nets,true,true);
  System.out.println("Found "+nets.size()+" best nets in attractor_slowShift!");
  System.out.println("The average network density is: "+getAvgDensity(nets));
  doModularityAnalysis(nets);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsSlow=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases

int[] motifNotFound=new int[twoFuncsSlow.length];
for(int[][] nework: nets){
 int z=0;
 boolean[] motifNotFoundTrack=new boolean[twoFuncsSlow.length];
 for(int i=0;i<motifNotFoundTrack.length;i++)
  motifNotFoundTrack[i]=true;
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  if(t==watchForThisCanonic){
   z++;
   network.printConnectivityMatrix(newrk,true);
   }
  twoFuncsSlow[t]++;
  motifNotFoundTrack[t]=false;
  }
 if((watchForThisCanonic>=0))
   System.out.println("Subnetwork "+watchForThisCanonic+" found "+z+" times!");
 for(int i=0;i<motifNotFound.length;i++)
   if(motifNotFoundTrack[i]) //this subnetwork was not found at all in this net
     motifNotFound[i]++;
 }
for(int i=0;i<motifNotFound.length;i++)
  if((motifNotFound[i]<50)||(i==watchForThisCanonic)){
    network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
    System.out.println("above (canoncial number "+i+") was not found in "+motifNotFound[i]+" nets.");
    }
/*
//do counting for randomized nets
double[] twoFuncsSlowRand=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] newo: nets){
 int[][] nework=network.randomizeConnectivityMatrix(newo);
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsSlowRand[t]++;
  }
 }

//do counting for originalSetting
Vector<int[][]> nets3=null;
try{
  nets3=new Vector<int[][]>();
  browseDir(new File("GRN_originalSetting"),nets3);
  System.out.println("Found "+nets3.size()+" best nets in GRN_originalSetting!");
  System.out.println("The average network density is: "+getAvgDensity(nets3));
  doModularityAnalysis(nets3);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] originalSetting=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: nets3)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  originalSetting[t]++;}
*/
//
//do counting for twoFuncsFull
Vector<int[][]> nets2=null;
try{
  nets2=new Vector<int[][]>();
  browseDir(new File("originalLongRun"),nets2,true,false);
  System.out.println("Found "+nets2.size()+" best nets in originalLongRun!");
  System.out.println("The average network density is: "+getAvgDensity(nets2));
  doModularityAnalysis(nets2);
}catch(Exception e){System.err.println("Error opening dir: "+e); System.exit(1);}
double[] twoFuncsFull=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] nework: nets2)
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  twoFuncsFull[t]++;}


System.out.println("check 20: old compare!");
//compare(twoFuncsSlow,twoFuncsFull,subnetsize);//twoFuncsFull //twoFuncsSlowBadNets
}

public static void allSubnetsTest(){
network nework=new network(5);
nework.addNodes(5);
nework.link(0,1);
nework.link(0,2);
nework.link(0,3);
nework.link(0,4);
nework.link(2,2);
nework.link(3,4);
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework.getConnectivityMatrixArray(true))){
  network.printConnectivityMatrix(newrk);
  }
}

public static void testit(){
network nework=new network(3);
nework.addNodes(3);
nework.link(1,1);
nework.link(2,2);
nework.link(1,2);
int i=network.getCanonicalInt(nework.getConnectivityMatrixArray());
network.printConnectivityMatrix(network.canonicalIntToConnMat(i,9));
if(badSubNet(nework.getConnectivityMatrixArray())){
 System.out.println("bad");
 }
System.out.println(i);
}


public static void main(String[] args){
//modularityTest();
//doComparisons();
//while(!tester()){}
//doComparisons3();
doComparisonsBigPop();
//testit();
//allSubnetsTest();
}

} 
